//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2

//
//
//
//
//

extern int    Periods     = 10;
extern double HighLowStep = 0.0005;

double max[];
double min[];
double high[];
double low[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   
   SetIndexBuffer(0,max);
   SetIndexBuffer(1,min);
   SetIndexBuffer(2,high);
   SetIndexBuffer(3,low);
   
   IndicatorShortName("Corridor of Price");
   
   return(0);
}

int deinit()

{ return(0); }

//
//
//
//
//

int start()
{
   
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(int i=limit; i>=0; i--)
   {
      if (i==(Bars-1)) { max[i] = High[i]; min[i] = Low[i]; continue; }
      high[i]     = iHigh(Symbol(),Period(),iHighest(Symbol(),Period(),MODE_HIGH,Periods,i));
      low[i]      = iLow(Symbol(),Period(),iLowest(Symbol(),Period(),MODE_LOW,Periods,i));
      max[i]      = MathMax(high[i],max[i+1]-HighLowStep);
      min[i]      = MathMin(low[i], min[i+1]+HighLowStep);
   }         
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------